#include <iostream>

using namespace std;

int main()
{
    int n, k;
    cin >> n >> k;
    int m[n][n];
    int r[k+1][n] = {0};
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> m[i][j];
            r[m[i][j]][j]+=i;
        }
    }
    int br = 0;
    bool imaPozitivnih = false;
    bool sledeciZamka = false;
    int uoceniBroj = -1;
    for (int i = 1; i <= k; i++) {
        imaPozitivnih = false;
        sledeciZamka = false;
        for (int j = 0; j < n; j++) {
            if (imaPozitivnih && r[i][j] == 0 && r[i][j] != r[i][j-1])
                    sledeciZamka = true;

            if (r[i][j] != 0) {
                if (sledeciZamka) break;
                if (imaPozitivnih && r[i][j] != uoceniBroj) break;
                imaPozitivnih = true;
                uoceniBroj = r[i][j];
            }
            if (j == n-1) {
                if (imaPozitivnih == false)
                    break;
                br++;
            }
        }
    }
    cout << br;
    return 0;
}